# include "tree.h"

# include <clocale>
# include <iostream>

using namespace std;

int main() try
{
  setlocale(LC_CTYPE, "");
  gr_prog prog = gr_parse(stdin);
  idt_gen gen;
  prog_a simple = make_oob_explicit(gr_to_simple(prog, gen));
  prog_c trans = a_to_c(simple);
  //print_program(trans);
  generate(cout, trans);
}catch(abort_compilation)
{
  return 1;
}catch(exception &e)
{
  cerr << "internal error: " << e.what() << "\n";
  return 2;
}catch(...)
{
  cerr << "internal error: unknown error\n";
  return 3;
}
